﻿namespace UltraExplorerBarSelectedItemText
{
    using Infragistics.Win;
    using Infragistics.Win.UltraWinExplorerBar;

    internal class DF : IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {

            //  Check if the UIElement to be drawn is EditorWithTextDisplayTextUIElement.
            //  If so and if we are at correct draw phase go on and change the Text of
            //  the UIElement
            var textElement = drawParams.Element as EditorWithTextDisplayTextUIElement;
            if(drawPhase == DrawPhase.BeforeDrawElement && textElement != null)
            {
                //  Get the group of the UIElement context. This way you will be sure
                //  you are working on the correct UIElement as well as you will be able
                //  to set the new text based on the group
                var group = textElement.GetContext() as UltraExplorerBarGroup;
                if(group != null)
                {
                    //  Create your custom header and assign it to the Text property
                    //  of the UIElement
                    var newHeader = string.Format("This is group {0}", group.Index);
                    textElement.Text = newHeader;
                }
            }

            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            //  Check if the UIElement to be drawn is EditorWithTextDisplayTextUIElement
            //  This UIElement will show the group header text. If so return before the
            //  UIElement is drawn.
            if(drawParams.Element is EditorWithTextDisplayTextUIElement)
            {
                return DrawPhase.BeforeDrawElement;
            }

            return DrawPhase.None;
        }
    }
}